<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="modal-header">
  <h4
    class="modal-title"
    id="modal-basic-title"
    [innerText]="actionEnum.ExternalSignature | actionName">
  </h4>
  <button
    type="button"
    class="btn-close"
    aria-label="close"
    (click)="activeModal.dismiss(commonMessages.ACTION_RESULT_CANCEL)">
  </button>
</div>

<div class="modal-body d-flex">
  <div class="w-50 me-4">
    <div
      id="signerListTitle"
      class="mb-2 fw-bold"
      [innerText]="messages.SIGNER_LIST_TITLE">
    </div>
    <div class="scrollable w-100">
      <table
        aria-labelledby="signerListTitle"
        class="w-100 bg-white table table-striped table-fixed table-borderless border-bottom table-text-overflow">
        <thead></thead>
        <tbody>
          <tr *ngIf="signerList.length === 0" class="text-secondary" [innerText]="messages.EMPTY_SIGNER_LIST_PLACEHOLDER"></tr>
          <tr
            *ngFor="let signer of signerList; let i = index;"
            [ngClass]="{'table-primary': i === currentMemberIndex}"
            (click)="editSigner(i)"
            class="pointer">
            <td>
              <fa-icon
                *ngIf="!checkSignerValidity(signer)"
                [icon]="commonIcons.WARNING_ICON"
                [ngbTooltip]="messages.BAD_SIGNER_FORM_DATA"
                (click)="removeSigner(i)"
                class="text-danger pe-2 pointer">
              </fa-icon>
              <span
                [innerText]="getSignerText(signer)"
                [ngbTooltip]="getSignerText(signer)">
              </span>
            </td>
            <td
              class="d-flex justify-content-end"
              *ngIf="areAllFoldersInFormState">
              <fa-icon
                [icon]="commonIcons.DELETE_ICON"
                [ngbTooltip]="commonMessages.DELETE"
                (click)="removeSigner(i)"
                class="text-danger pe-2 pointer">
              </fa-icon>
            </td>
          </tr>
        </tbody>
      </table>
    </div>

    <button
      *ngIf="areAllFoldersInFormState"
      [text]="messages.ADD_SIGNER"
      [style]="styleEnum.NORMAL"
      [icon]="commonIcons.ADD_ICON"
      (click)="addSigner()"
      ls-button>
    </button>
  </div>
  <div class="form-group w-75 ms-4">
    <div class="d-flex flex-column">
      <form
        class="ls-form w-100"
        [formGroup]="externalSignatureForm">

        <div class="form-group">
          <label
            for="firstname"
            class="required"
            [innerText]="messages.EXTERNAL_SIGNATURE_FORM_LABEL_FIRSTNAME">
          </label>
          <input
            id="firstname"
            type="text"
            class="form-control"
            formControlName="firstname">
        </div>
        <div class="form-group">
          <label
            for="lastname"
            class="required"
            [innerText]="messages.EXTERNAL_SIGNATURE_FORM_LABEL_LASTNAME">
          </label>
          <input
            type="text"
            id="lastname"
            class="form-control"
            formControlName="lastname">
        </div>
        <div class="form-group">
          <label
            for="mail"
            class="required"
            [innerText]="messages.EXTERNAL_SIGNATURE_FORM_LABEL_MAIL_ADDRESS">
          </label>
          <input
            type="text"
            id="mail"
            class="form-control"
            formControlName="mail">
        </div>
        <div class="form-group">
          <label
            for="phone"
            class="required"
            [innerText]="messages.EXTERNAL_SIGNATURE_FORM_LABEL_PHONE"></label>
          <input
            type="text"
            id="phone"
            class="form-control"
            formControlName="phone">
        </div>
      </form>
    </div>

    <app-metadata-form
      [tenantId]="tenantId"
      [(folders)]="folders"
      [performedAction]="performedAction"
      [(validationMetadataFormValid)]="validationMetadataFormValid">
    </app-metadata-form>
  </div>

</div>

<div
  *ngIf="areAllFoldersInSignedState"
  class="mx-3 mb-3 alert alert-info"
  role="alert">
  <p class="pt-3">
    <fa-icon
      class="pe-2"
      aria-hidden="true"
      [icon]="infoIcon">
    </fa-icon>
    {{ messages.EVERY_SIGNER_HAS_SIGNED }}
  </p>
  <p>
    {{ messages.TIME_THRESHOLD_INFO }}
    <br>
    {{ messages.FINISH_STEP_INFO }}
  </p>
</div>

<div class="modal-footer">
  <button
    (click)="activeModal.dismiss(commonMessages.ACTION_RESULT_CANCEL)"
    ls-button-cancel>
  </button>
  <button
    *ngIf="areAllFoldersInFormState || areAllFoldersInSignedState"
    [disabled]="(areAllFoldersInFormState && (!areAllSignersValid || isProcessing)) || !validationMetadataFormValid"
    [processing]="isProcessing"
    [text]="areAllFoldersInSignedState ? commonMessages.FORCE_STEP_NOW : actionEnum.ExternalSignature | actionName:true"
    [icon]="actionEnum.ExternalSignature | actionIcon"
    [style]="styleEnum.NORMAL"
    (click)="submit()"
    ls-button-save>
  </button>
</div>
